VERSION 5.00
Begin VB.Form frmHotKeys 
   AutoRedraw      =   -1  'True
   Caption         =   "Set My HotKey!"
   ClientHeight    =   2055
   ClientLeft      =   3210
   ClientTop       =   1530
   ClientWidth     =   3105
   Icon            =   "frmHotKeys.frx":0000
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   137
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   207
   Begin VB.ComboBox cbModifiers 
      Height          =   315
      ItemData        =   "frmHotKeys.frx":000C
      Left            =   1328
      List            =   "frmHotKeys.frx":000E
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   345
      Width           =   1605
   End
   Begin VB.ComboBox cbKeyCodes 
      Height          =   315
      ItemData        =   "frmHotKeys.frx":0010
      Left            =   173
      List            =   "frmHotKeys.frx":0012
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   345
      Width           =   735
   End
   Begin VB.CommandButton cmdAssociateHotKey 
      Caption         =   "Activate HotKey"
      Height          =   405
      Left            =   615
      TabIndex        =   0
      Top             =   945
      Width           =   1935
   End
   Begin VB.Label lblCurrentHotKey 
      Alignment       =   2  'Center
      Caption         =   "Active HotKey: (none)"
      Height          =   270
      Left            =   60
      TabIndex        =   5
      Top             =   1650
      Width           =   3000
   End
   Begin VB.Label Label1 
      Caption         =   "Modifiers"
      Height          =   225
      Index           =   1
      Left            =   1365
      TabIndex        =   4
      Top             =   105
      Width           =   780
   End
   Begin VB.Label Label1 
      Caption         =   "HotKey"
      Height          =   225
      Index           =   0
      Left            =   240
      TabIndex        =   3
      Top             =   105
      Width           =   780
   End
End
Attribute VB_Name = "frmHotKeys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to use the SendMessage API function and
  ' the WM_SETHOTKEY message to set a global hotkey for a VB form
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  '
  ' thanks go to Ed Stegman for the idea and the preliminary code for
  ' this demo!
  '
  
  ' our hotkey object
  Private m_oHotKey As cHotKey

Private Sub cmdAssociateHotKey_Click()

  Dim sMsg$, bShowMsg As Boolean
  
  ' make sure we have an instance of our cHotKey object....
  If m_oHotKey Is Nothing Then Set m_oHotKey = New cHotKey
   
  ' set the hotkey based on the values chosen in the comboboxes.
  Select Case m_oHotKey.SetHotKey(Me.hWnd, cbKeyCodes.ItemData(cbKeyCodes.ListIndex), cbModifiers.ItemData(cbModifiers.ListIndex))
    Case [Duplicate HotKey]
      sMsg = "Duplicate HotKey."
      bShowMsg = True
      
    Case [Invalid hWnd]
      sMsg = "Invalid Window."
      bShowMsg = True
    
    Case [Invalid KeyCode]
      sMsg = "Invalid KeyCode."
      bShowMsg = True
      
    Case Success
      lblCurrentHotKey.Caption = "Active HotKey: " & cbModifiers.Text & " + " & cbKeyCodes.Text
      
  End Select
    
  If bShowMsg Then
    MsgBox "Hot Key failed.  " & sMsg
    lblCurrentHotKey.Caption = "Active HotKey: (none)"
  End If
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  ' remove the hotkey for the window.  according to the documentation,
  ' the hotkey will be automatically removed when the app exits.  however,
  ' it is always best to do clean up yourself whenever possible.
  If Not m_oHotKey Is Nothing Then
    Call m_oHotKey.KillHotKey(Me.hWnd)
    
    Set m_oHotKey = Nothing
  End If
  
End Sub

Private Sub Form_Load()
  ' load the comboboxes with the hotkey choices....
  
  With cbModifiers
    .AddItem "Shift"
    .ItemData(.NewIndex) = HOTKEYF_SHIFT
    .AddItem "Ctrl"
    .ItemData(.NewIndex) = HOTKEYF_CONTROL
    .AddItem "Alt"
    .ItemData(.NewIndex) = HOTKEYF_ALT
    .AddItem "Shift + Ctrl"
    .ItemData(.NewIndex) = HOTKEYF_SHIFT Or HOTKEYF_CONTROL
    .AddItem "Shift + Alt"
    .ItemData(.NewIndex) = HOTKEYF_SHIFT Or HOTKEYF_ALT
    .AddItem "Ctrl + Alt"
    .ItemData(.NewIndex) = HOTKEYF_CONTROL Or HOTKEYF_ALT
    .AddItem "Shift + Ctrl + Alt"
    .ItemData(.NewIndex) = HOTKEYF_SHIFT Or HOTKEYF_CONTROL Or HOTKEYF_ALT
  
    ' set the default
    .Text = "Shift + Ctrl"
  End With
  

  With cbKeyCodes
    .AddItem "0"
    .ItemData(.NewIndex) = vbKey0
    .AddItem "1"
    .ItemData(.NewIndex) = vbKey1
    .AddItem "2"
    .ItemData(.NewIndex) = vbKey2
    .AddItem "3"
    .ItemData(.NewIndex) = vbKey3
    .AddItem "4"
    .ItemData(.NewIndex) = vbKey4
    .AddItem "5"
    .ItemData(.NewIndex) = vbKey5
    .AddItem "6"
    .ItemData(.NewIndex) = vbKey6
    .AddItem "7"
    .ItemData(.NewIndex) = vbKey7
    .AddItem "8"
    .ItemData(.NewIndex) = vbKey8
    .AddItem "9"
    .ItemData(.NewIndex) = vbKey9
    .AddItem "A"
    .ItemData(.NewIndex) = vbKeyA
    .AddItem "B"
    .ItemData(.NewIndex) = vbKeyB
    .AddItem "C"
    .ItemData(.NewIndex) = vbKeyC
    .AddItem "D"
    .ItemData(.NewIndex) = vbKeyD
    .AddItem "E"
    .ItemData(.NewIndex) = vbKeyE
    .AddItem "F"
    .ItemData(.NewIndex) = vbKeyF
    .AddItem "G"
    .ItemData(.NewIndex) = vbKeyG
    .AddItem "H"
    .ItemData(.NewIndex) = vbKeyH
    .AddItem "I"
    .ItemData(.NewIndex) = vbKeyI
    .AddItem "J"
    .ItemData(.NewIndex) = vbKeyJ
    .AddItem "K"
    .ItemData(.NewIndex) = vbKeyK
    .AddItem "L"
    .ItemData(.NewIndex) = vbKeyL
    .AddItem "M"
    .ItemData(.NewIndex) = vbKeyM
    .AddItem "N"
    .ItemData(.NewIndex) = vbKeyN
    .AddItem "O"
    .ItemData(.NewIndex) = vbKeyO
    .AddItem "P"
    .ItemData(.NewIndex) = vbKeyP
    .AddItem "Q"
    .ItemData(.NewIndex) = vbKeyQ
    .AddItem "R"
    .ItemData(.NewIndex) = vbKeyR
    .AddItem "S"
    .ItemData(.NewIndex) = vbKeyS
    .AddItem "T"
    .ItemData(.NewIndex) = vbKeyT
    .AddItem "U"
    .ItemData(.NewIndex) = vbKeyU
    .AddItem "V"
    .ItemData(.NewIndex) = vbKeyV
    .AddItem "W"
    .ItemData(.NewIndex) = vbKeyW
    .AddItem "X"
    .ItemData(.NewIndex) = vbKeyX
    .AddItem "Y"
    .ItemData(.NewIndex) = vbKeyY
    .AddItem "Z"
    .ItemData(.NewIndex) = vbKeyZ
    .AddItem "F1"
    .ItemData(.NewIndex) = vbKeyF1
    .AddItem "F2"
    .ItemData(.NewIndex) = vbKeyF2
    .AddItem "F3"
    .ItemData(.NewIndex) = vbKeyF3
    .AddItem "F4"
    .ItemData(.NewIndex) = vbKeyF4
    .AddItem "F5"
    .ItemData(.NewIndex) = vbKeyF5
    .AddItem "F6"
    .ItemData(.NewIndex) = vbKeyF6
    .AddItem "F7"
    .ItemData(.NewIndex) = vbKeyF7
    .AddItem "F8"
    .ItemData(.NewIndex) = vbKeyF8
    .AddItem "F9"
    .ItemData(.NewIndex) = vbKeyF9
    .AddItem "F10"
    .ItemData(.NewIndex) = vbKeyF10
    .AddItem "F11"
    .ItemData(.NewIndex) = vbKeyF11
    .AddItem "F12"
    .ItemData(.NewIndex) = vbKeyF12

    ' you can use any keycode except Escape, Space & Tab.
    ' all of the available keys are not implemented in this demo

    ' set the default
    .Text = "H"
  End With
  
End Sub

